<?php
/**
 * @author		isApp.it Team
 * @copyright	Copyright (C) 2011 isApp.it. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link		http://www.isapp.it
 */
 
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport( 'joomla.filesystem.folder' );

class mod_jpaydayInstallerScript
{
	/**
	 * Joomla Version
	 * @var String
	 */
	private $_joomlaVersion = null;
	/**
	 * Joomla!3.x
	 */
	const JOOMLA_3X = 3;
	/**
	 * Joomla!2.x
	 */
	const JOOMLA_2X = 2;
	/**
	 * Joomla!1.x
	 */
	const JOOMLA_1X = 1;
	
	public function __construct() {
		$this->getJoomlaVersion();
	}
	/**
	 * method to install the component
	 *
	 * @return void
	 */
	function install($parent) 
	{
		// Get a db connection.
		$db = JFactory::getDbo();
		
		/* ========= select find module id ========= */
		// Create a new query object.
		$query = $db->getQuery(true);
		//find id module
		$query->select(array('id'));
		$query->from('#__modules');
		$query->where('module = '. $db->quote('mod_jpayday'));
		$query->where('published = 0');
		
		// Reset the query using our newly populated query object.
		$db->setQuery($query);
		
		// Load the results as a list of stdClass objects.
		$results = $db->loadObjectList();
		$id = $results[0]->id;
		
		
		/* ========= update publish module ========= */
		// Create a new query object.
		$query = $db->getQuery(true);
		
		//publish module
		$position = 'debug';
		//Build the query
		$query->update("#__modules");
		$query->set('published = 1');
		$query->set('position = '.$db->quote($position));
		$query->set('showtitle = 0');
		$query->where('id = '. $id);
		$db->setQuery($query);
		 
		//execute db object
		try {
			if ($this->_joomlaVersion == mod_jpaydayInstallerScript::JOOMLA_3X) {
				$result = $db->execute();
			} else {
				$db->query();
			}
		} catch (Exception $e) {
			//print the errors
			print_r($e);
		}
		
		/* ========= insert record moduele-menu ========= */
		// Create a new query object.
		$query = $db->getQuery(true);
		
		// Insert columns.
		$columns = array('moduleid', 'menuid');
		
		// Insert values.
		$values = array($id, 0);
		
		//insert record moduele-menu
		$query
		->insert($db->quoteName('#__modules_menu'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
		
		// Reset the query using our newly populated query object.
		$db->setQuery($query);
		
		try {
			// Execute the query in Joomla 2.5.
			if ($this->_joomlaVersion == mod_jpaydayInstallerScript::JOOMLA_3X) {
				$result = $db->execute();
			} else {
				$db->query();
			}
		} catch (Exception $e) {
			// catch any database errors.
			print_r($e);
		}
		
		return true;
	}
	
	public function getJoomlaVersion() {
		JLoader::import( 'joomla.version' );
		$version = new JVersion();
		// check joomla version
		if (version_compare($version->getShortVersion(), 3.0, '>=')) {
			$this->_joomlaVersion = mod_jpaydayInstallerScript::JOOMLA_3X;
		} elseif (version_compare($version->getShortVersion(), 3.0, '<') && version_compare($version->getShortVersion(), 2.0, '>=')) {
			$this->_joomlaVersion = mod_jpaydayInstallerScript::JOOMLA_2X;
		} else {
			// errore versione non supportata
			$this->_joomlaVersion = mod_jpaydayInstallerScript::JOOMLA_1X;
		}
		return $this->_joomlaVersion;
	}
	
}